var fs = require('fs');
var ws = require('nodejs-websocket');
var serialport = require("serialport");
var SerialPort = serialport.SerialPort

var readings = [];    
if (process.argv.length != 3) {
    console.log("Usage:\n" + process.argv[0] + " " + 
		process.argv[1] + " " + "SerialPort\n");
    process.exit(1);
}

var serialPort = new SerialPort(process.argv[2], {
	baudrate: 115200,
	parser: serialport.parsers.readline("\r\n")
    }, false);

serialPort.open(function (error) {
	if (error) {
	    console.log('failed to open: '+error);
	    process.exit(2);
	} 
	else {
	    console.log('serial port open');
	    serialPort.on('data', function(data) {
		    readings[data.charAt(0)] = data.slice(2);
		});
	}
    });

ws.createServer(function (conn) {
	console.log("New connection");
	conn.on("text", function (str) {
		console.log("Received " + str);
		var dataType = str.charAt(0);
		try {
			conn.sendText(readings[dataType]);
			console.log("Sent " + readings[dataType]);
		}
		catch(err) {
			var msg = "Invalid request: " + dataType
			conn.sendText(msg);
			console.log(msg);
		}
	    });
	conn.on("close", function (code, reason) {
		console.log("Connection closed");
	    });
    }).listen(8001);
