var fs = require('fs');
var ws = require('nodejs-websocket')
var serialport = require("serialport");
var SerialPort = serialport.SerialPort
var readings = [];
    
if (process.argv.length != 4) {
    console.log("Usage:\n" + process.argv[0] + " " + 
		process.argv[1] + " SerialPort" + " server_url");
    process.exit(1);
}

var serialPort = new SerialPort(process.argv[2], {
    baudrate: 115200,
    parser: serialport.parsers.readline("\r\n")
}, false);

serialPort.open(function (error) {
    if (error) {
	console.error(error);
	process.exit(2);
    } 
    else {
	console.info('serial port open');
	serialPort.on('data', function(data) {
	    readings[data.charAt(0)] = data.slice(2);
	});
    }
});

var conn = ws.connect(process.argv[3])

conn.on("connect", function() {
    console.log("Connection to server opened");
    conn.sendText("I am the PI");
});

conn.on("close", function(code, reason) {
    console.log("Connection closed " + code + " " + reason);
    process.exit(0);
});

conn.on("text", function (str) {
    console.log("Received: " + str);
    var dataType = str.charAt(0);
    try {
	conn.sendText(readings[dataType]);
	console.log("Sent: " + readings[dataType]);
    }
    catch(err) {
	var msg = "Invalid request: " + dataType;
	conn.sendText(msg);
	console.log("Sent: " + msg);
    }
});

conn.on("error", function (err) {
    console.error(err);
    process.exit(3);
});